unit odgtest;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ComCtrls, oodrawwriter, ExtCtrls,
  TAGraph,TASeries, TAChartUtils;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Chart1: TChart;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    testodg:Todg;
    { private declarations }
  public

    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var Serie:TSerie;
    i:integer;
begin
  Serie:=Tserie.create(chart1);
  chart1.AddSeries(Serie);
  Serie.ShowLines:=true;
  Serie.ShowPoints:=true;
  for i:=1 to 100 do
    Serie.AddXY(i,(i+i)/(i*i));
  chart1.BottomAxis.Visible:=true;
  chart1.LeftAxis.Visible:=true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var    x,y:integer;
begin
  // make the TestODG
  TestODG:=Todg.create;
  // clear the image
  image1.Canvas.Clear;
  image1.Canvas.FloodFill(100,100,clwhite,fsborder);

    // if something is not provided by my Class it goes to the image ;)
    // needed because there is a bad hack in the Chart to write the axis labels
  TCanvas(testodg).Handle:=image1.Canvas.Handle;

    //start a new Group
  testodg.GroupStart;
    //draw the chart into the ODG File
  chart1.DrawOnCanvas(Rect(0,0,image1.Width,image1.Height),testodg);
    // finish the Group
  testodg.GroupEnd;
    // Draw the chat onto the image in the Window
  chart1.DrawOnCanvas(Rect(0,0,image1.Width,image1.Height),image1.Canvas);
    // set Pen/Bush styles for Image
  image1.Canvas.Pen.Width:=3;
  image1.Canvas.Pen.style:=psSolid;
  image1.Canvas.Pen.Color:=clRed;
  image1.Canvas.Brush.Style:=bsSolid;
  image1.Canvas.Brush.Color:=clBlue;
    // set Pen/Brush styles for ODG
  Testodg.Pen.Width:=3;
  Testodg.Pen.style:=psSolid;
  Testodg.Pen.Color:=clRed;
  Testodg.Brush.Style:=bsSolid;
  Testodg.Brush.Color:=clBlue;
    // Draw a Chord into both
  Testodg.chord(20,30,200,100,0,90*16);
  image1.Canvas.chord(20,30,200,100,0,90*16);

    // Make a new Group for the gray square to show Pixels[x,y]
  testodg.GroupStart;
  for x:=10 to 20 do
      for y:=10 to 20 do
      Begin
        image1.Canvas.Pixels[x,y]:=RGBToColor(x+y*10,x+y*10,x+y*10);
        testodg.Pixels[x,y]:=RGBToColor(x+y*10,x+y*10,x+y*10);
      end;
  testodg.GroupEnd;
    // copy the resulted picture also to the ODG
  Testodg.draw(100,100,Image1.Picture.Bitmap);
    // schreibe das ODG
  testodg.WriteODG('new.odg');
    // -> Trashcan
  testodg.free;
end;




initialization
  {$I odgtest.lrs}

end.

